<?php

class ControllerextensionpaymentHpjAlipay extends Controller
{

    private $error = array();
 
    private function _redirect($url, $status = 302) {
        header('location: ' . str_replace(array('&amp;', "\n", "\r"), array('&', '', ''), $url), true, $status);
        exit();
    }
    
    public function index()
    {
        $this->load->language('extension/payment/hpjalipay');
        $this->document->setTitle($this->language->get('heading_title'));
        $this->load->model('setting/setting');
       
        if (($this->request->server['REQUEST_METHOD'] == 'POST') && $this->validate()) {
            $this->model_setting_setting->editSetting('payment_hpjalipay', $this->request->post);
            $this->session->data['success'] = $this->language->get('text_success');
            $url =$this->url->link('extension/payment/hpjalipay', 'user_token=' . $this->session->data['user_token'], 'SSL');
            
            $this->_redirect($url);
        }
        
        $data['success'] = isset($this->session->data['success'])?$this->session->data['success']:null;
        $this->session->data['success']=null;
        $data['heading_title'] = $this->language->get('heading_title');
        $data['text_enabled'] = $this->language->get('text_enabled');
        $data['text_disabled'] = $this->language->get('text_disabled');
        $data['text_all_zones'] = $this->language->get('text_all_zones');
        $data['text_yes'] = $this->language->get('text_yes');
        $data['text_no'] = $this->language->get('text_no');
        
        $data['entry_hpjalipay_appid'] = $this->language->get('entry_appid');
      
        $data['entry_hpjalipay_appsecret'] = $this->language->get('entry_appsecret');
        $data['entry_hpjalipay_order_prefix']= $this->language->get('entry_order_prefix');	
		$data['entry_hpjalipay_exchange_rate']= $this->language->get('entry_exchange_rate');
        $data['entry_hpjalipay_transaction_url'] = $this->language->get('entry_transaction_url');
        
        $data['entry_order_status'] = $this->language->get('entry_order_status');
        $data['entry_order_succeed_status'] = $this->language->get('entry_order_succeed_status');
        $data['entry_order_payWait_status_id'] = $this->language->get('entry_order_payWait_status_id');
        $data['entry_order_failed_status'] = $this->language->get('entry_order_failed_status');
        
        $data['entry_geo_zone'] = $this->language->get('entry_geo_zone');
        $data['entry_status'] = $this->language->get('entry_status');
        $data['entry_sort_order'] = $this->language->get('entry_sort_order');
        
        $data['button_save'] = $this->language->get('button_save');
        $data['button_cancel'] = $this->language->get('button_cancel');       
        $data['tab_general'] = $this->language->get('tab_general');
        
        if (isset($this->error['warning'])) {
            $data['error_warning'] = $this->error['warning'];
        } else {
            $data['error_warning'] = '';
        }
        
        if (isset($this->error['error_appid'])) {
            $data['error_appid'] = $this->error['error_appid'];
        } else {
            $data['error_appid'] = '';
        }
        
        if (isset($this->error['error_appsecret'])) {
            $data['error_appsecret'] = $this->error['error_appsecret'];
        } else {
            $data['error_appsecret'] = '';
        }
        
        $data['breadcrumbs'] = array();
        
        $data['breadcrumbs'][] = array(
            'text' => $this->language->get('text_home'),
            'href' => $this->url->link('common/dashboard', 'user_token=' . $this->session->data['user_token'], 'SSL'),
            'separator' =>false
        );
        
        
       $url_payment =$this->url->link('marketplace/extension', 'type=payment&user_token=' . $this->session->data['user_token'], 'SSL');
        
        $data['breadcrumbs'][] = array(
            'text' => $this->language->get('text_payment'),
            'href' => $url_payment,
            'separator' => '::'
        );
         $url_payment= $this->url->link('extension/payment/hpjalipay', 'user_token=' . $this->session->data['user_token'], 'SSL');
        
        $data['breadcrumbs'][] = array(
            'text' => $this->language->get('heading_title'),
            'href' =>$url_payment,
            'separator' => '::'
        );
        
        $data['action'] = $this->url->link('extension/payment/hpjalipay', 'user_token=' . $this->session->data['user_token'], 'SSL');  
        
        $data['cancel'] = $this->url->link('marketplace/extension', 'type=payment&user_token=' . $this->session->data['user_token'], 'SSL');	
   
      
        if (isset($this->request->post['payment_hpjalipay_appid'])) {
            $data['payment_hpjalipay_appid'] = $this->request->post['payment_hpjalipay_appid'];
        } else {
            $data['payment_hpjalipay_appid'] = $this->config->get('payment_hpjalipay_appid');
        }
       
        if (isset($this->request->post['payment_hpjalipay_appsecret'])) {
            $data['payment_hpjalipay_appsecret'] = $this->request->post['payment_hpjalipay_appsecret'];
        } else {
            $data['payment_hpjalipay_appsecret'] = $this->config->get('payment_hpjalipay_appsecret');
        }
        
        if (isset($this->request->post['payment_hpjalipay_transaction_url'])) {
            $data['payment_hpjalipay_transaction_url'] = $this->request->post['payment_hpjalipay_transaction_url'];
        } else {
            $data['payment_hpjalipay_transaction_url'] = $this->config->get('payment_hpjalipay_transaction_url');
        }
        if(empty($data['payment_hpjalipay_transaction_url'])){
            $data['payment_hpjalipay_transaction_url'] = 'https://api.xunhupay.com';
        }
        
        if (isset($this->request->post['payment_hpjalipay_order_prefix'])) {
            $data['payment_hpjalipay_order_prefix'] = $this->request->post['payment_hpjalipay_order_prefix'];
        } else {
            $data['payment_hpjalipay_order_prefix'] = $this->config->get('payment_hpjalipay_order_prefix');
        }
        
        if (isset($this->request->post['payment_hpjalipay_exchange_rate'])) {        
			$data['payment_hpjalipay_exchange_rate'] = $this->request->post['payment_hpjalipay_exchange_rate'];   
		} else {            
			$data['payment_hpjalipay_exchange_rate'] = $this->config->get('payment_hpjalipay_exchange_rate');            
			if(empty($data['payment_hpjalipay_exchange_rate'])){                
				$data['payment_hpjalipay_exchange_rate'] = '1';      
			}    
		}		
        $data['callback'] = HTTP_CATALOG . 'index.php?route=payment/hpjalipay/callback';
       
        if (isset($this->request->post['payment_hpjalipay_order_succeed_status_id'])) {
            $data['payment_hpjalipay_order_succeed_status_id'] = $this->request->post['payment_hpjalipay_order_succeed_status_id'];
        } else {
            $data['payment_hpjalipay_order_succeed_status_id'] = $this->config->get('payment_hpjalipay_order_succeed_status_id');
            if(!$data['payment_hpjalipay_order_succeed_status_id']){
                $data['payment_hpjalipay_order_succeed_status_id']='2';
            }
        }
        
        if (isset($this->request->post['payment_hpjalipay_order_failed_status_id'])) {
            $data['payment_hpjalipay_order_failed_status_id'] = $this->request->post['payment_hpjalipay_order_failed_status_id'];
        } else {
            $data['payment_hpjalipay_order_failed_status_id'] = $this->config->get('payment_hpjalipay_order_failed_status_id');
            if(! $data['payment_hpjalipay_order_failed_status_id']){
                $data['payment_hpjalipay_order_failed_status_id']='10';
            }
        }
        
        $this->load->model('localisation/order_status');
        
        $data['order_statuses'] = $this->model_localisation_order_status->getOrderStatuses();
        
        if (isset($this->request->post['payment_hpjalipay_geo_zone_id'])) {
            $data['payment_hpjalipay_geo_zone_id'] = $this->request->post['payment_hpjalipay_geo_zone_id'];
        } else {
            $data['payment_hpjalipay_geo_zone_id'] = $this->config->get('payment_hpjalipay_geo_zone_id');
        }
        
        $this->load->model('localisation/geo_zone');
        
        $data['geo_zones'] = $this->model_localisation_geo_zone->getGeoZones();
        
        if (isset($this->request->post['payment_hpjalipay_status'])) {
            $data['payment_hpjalipay_status'] = $this->request->post['payment_hpjalipay_status'];
        } else {
            $data['payment_hpjalipay_status'] = $this->config->get('payment_hpjalipay_status');
        }
        
        if (isset($this->request->post['payment_hpjalipay_sort_order'])) {
            $data['payment_hpjalipay_sort_order'] = $this->request->post['payment_hpjalipay_sort_order'];
        } else {
            $data['payment_hpjalipay_sort_order'] = $this->config->get('payment_hpjalipay_sort_order');
        }
        
        $data['header'] = $this->load->controller('common/header');
		$data['column_left'] = $this->load->controller('common/column_left');
		$data['footer'] = $this->load->controller('common/footer');

		$this->response->setOutput($this->load->view('extension/payment/hpjalipay', $data));
       
    }

    protected function validate()
    {
        if (! $this->user->hasPermission('modify', 'extension/payment/hpjalipay')) {
            $this->error['warning'] = $this->language->get('error_permission');
        }
        
        return ! $this->error;
    }
}
?>